//+------------------------------------------------------------------+
//|                                                       NewATR.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern int       PerATR = 13;
//---- buffers
double MyATR[];
double ATRBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ATRBuffer1);
   SetIndexBuffer(1,MyATR);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int    counted_bars=IndicatorCounted();
//---- 
   int limit,limit1,i;
   if (counted_bars==0)
     {
      limit=Bars-PerATR;
      limit1=limit-PerATR;
     }
   if (counted_bars>0)
     {
      limit=Bars-counted_bars;
      limit1=limit;
     }
   limit--;
   limit1--;
   for(i=limit; i>=0;i--)
   {      
      double prevclose=Close[i+1];
      MyATR[i] = (MathMax(High[i],prevclose)-MathMin(Low[i],prevclose))/MathMin(Low[i],prevclose);
   }     
  for(i=limit1; i>=0;i--)
   ATRBuffer1[i]=iMAOnArray(MyATR,0,PerATR,0,MODE_SMA,i);
//----
   return(0);
  }
//+------------------------------------------------------------------+